VERSION 2.00
Begin Form PrintOpt 
   BackColor       =   &H00E0FFFF&
   Caption         =   "Printer Options"
   Height          =   2055
   Icon            =   PRINTOPT.FRX:0000
   Left            =   1290
   LinkMode        =   1  'Source
   LinkTopic       =   "PrintOpt"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   1650
   ScaleWidth      =   4650
   Top             =   2130
   Width           =   4770
   Begin TextBox Text1 
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   1080
      Width           =   3255
   End
   Begin CommandButton CmdFont 
      Caption         =   "&Font"
      Height          =   375
      Left            =   3600
      TabIndex        =   4
      Top             =   1080
      Width           =   855
   End
   Begin CommonDialog CMDialog1 
      Left            =   3720
      Top             =   1560
   End
   Begin OptionButton OptWindowsPrinter 
      BackColor       =   &H00E0FFFF&
      Caption         =   "&Windows Print Manager"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   3015
   End
   Begin OptionButton OptHPPrinter 
      BackColor       =   &H00E0FFFF&
      Caption         =   "&HP PCL5 Printer on LPT1: "
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
   Begin CommandButton CmdClose 
      Caption         =   "&Close"
      Default         =   -1  'True
      Height          =   375
      Left            =   3600
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin CommandButton CmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   375
      Left            =   3600
      TabIndex        =   3
      Top             =   600
      Width           =   855
   End
End

Sub CmdCancel_Click ()
   Unload PrintOpt
End Sub

Sub CmdClose_Click ()
  If OptHPPrinter.Value = True Then
    CfgRec.PrintOptNumber = 1
  Else
    CfgRec.PrintOptNumber = 2
  End If
  CfgFileNo% = FreeFile
  Open "deli.cfg" For Random As CfgFileNo% Len = Len(CfgRec)
  Put #CfgFileNo%, 1, CfgRec
  Close CfgFileNo%
  Unload PrintOpt
End Sub

Sub CmdFont_Click ()
  CMDialog1.Flags = CF_PRINTERFONTS Or CF_FIXEDPITCHONLY
  CMDialog1.FontSize = CfgRec.FontSize
  CMDialog1.FontName = LTrim$(CfgRec.FontName)
  CMDialog1.Action = 4
  CfgRec.FontName = CMDialog1.FontName
  CfgRec.FontSize = CMDialog1.FontSize
  Text1.Text = Str$(CfgRec.FontSize) + " pt " + RTrim$(CfgRec.FontName)
End Sub

Sub Form_Load ()
    Top = DeliMain.Top + 1650
    Left = DeliMain.Left + 1650
    Height = 2070
    Width = 4770
    If FileExists("deli.cfg") Then
      CfgFileNo% = FreeFile
      Open "deli.cfg" For Random As CfgFileNo% Len = Len(CfgRec)
      Get #CfgFileNo%, 1, CfgRec
      Close CfgFileNo%
    Else
      CfgRec.PrintOptNumber = 1
      CfgRec.FontName = Printer.FontName
      CfgRec.FontSize = Printer.FontSize
      CfgRec.TopMargin = 27
      CfgRec.LeftMargin = 53
      CfgRec.LabelWidth = 338
      CfgRec.LabelHeight = 123
      CfgRec.DescriptionX = 0
      CfgRec.DescriptionY = 0
      CfgRec.DescriptionFS = 12
      CfgRec.RecipeNoX = 0
      CfgRec.RecipeNoY = 27
      CfgRec.RecipeNoFS = 10
      CfgRec.PriceX = 183
      CfgRec.PriceY = 83
      CfgRec.PriceFS = 40
      CfgRec.ShelfLifeX = 100
      CfgRec.ShelfLifeY = 27
      CfgRec.ShelfLifeFS = 10
      CfgRec.LabelRows = 6
      CfgRec.LabelColumns = 3
      CfgRec.LandPortFlag = 2 'Landscape
    End If
    Text1.Text = Str$(CfgRec.FontSize) + " pt " + RTrim$(CfgRec.FontName)
    Select Case CfgRec.PrintOptNumber
      Case 1
        OptHPPrinter.Value = True
      Case 2
        OptWindowsPrinter.Value = True
    End Select
End Sub

