VERSION 2.00
Begin Form PrnAuto 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Print Suggest Changes"
   ControlBox      =   0   'False
   Height          =   2370
   Icon            =   PRNAUTO.FRX:0000
   Left            =   3420
   LinkTopic       =   "PrnAuto"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1965
   ScaleWidth      =   2925
   Top             =   2325
   Width           =   3045
   Begin CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
End

Sub Command1_Click ()
  PrintCancelFlag = True
End Sub

Sub Form_Activate ()
  Unload SupMnt
  Unload RecGrMnt
  Unload IngGrMnt
  Unload IngreMnt
  Unload RecipMnt
  If CfgRec.PrintOptNumber = 1 Then
    PrintRoutine
  Else
    WinPrintRoutine
  End If
End Sub

Sub PrintRoutine ()
MainLine:
    t% = DoEvents()
    GoSub Initialize
    GoSub PrintRecipe
    GoTo ExitProgram

Initialize:
    PrintCancelFlag = False
    OutFile% = FreeFile
    Open "\dev\lpt1" For Output As OutFile% Len = 166
    On Local Error GoTo ErrorRoutine
    SaveRecGroup$ = "XXX"
    Return

PrintRecipe:
    Print "Deli Menu System"
    Print "Auto Price Print"
    Print "Printing...Please Wait..."
     GoSub PrintHeader
    t% = DoEvents()
    FirstRecipeKey1
      Do
        If ItemsPrinted% > 38 Then
          GoSub PrintHeader
        End If
        RecGroupRec.RecGroup = RecipeRec.RecGroup
        ReadRecGroup
        If RecGroupSt% <> 0 Then
          RecGroupRec.RecGroupDesc = "NOT FOUND"
        End If
        If SaveRecGroup$ <> RecGroupRec.RecGroup Then
          Print #OutFile%, Tab(Offset% + 2); RecGroupRec.RecGroup; " "; RecGroupRec.RecGroupDesc;
          Print #OutFile%, " --------------------------------------------"
          ItemsPrinted% = ItemsPrinted% + 1
          If ItemsPrinted% > 38 Then
            GoSub PrintHeader
          End If
          SaveRecGroup$ = RecGroupRec.RecGroup
        End If
        'Get lines of ingredients
        RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
        GetGERecipeDet
        If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
          MsgUnknownRecipeDetError
          GoTo ExitProgram
        End If
        Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
            IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
            ReadIngredient
            If IngredientSt% = 0 Then
              PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
              PrNoUnits# = RecipeDetRec.RecDetQty
              GoSub ProcessOneIngredient
            End If
            t% = DoEvents()
            NextRecipeDet
        Loop
        OldRetail = RecipeRec.RecRetail
        NewRetailFlag$ = "N"
        GoSub CalculateNewRetail
        If NewRetailFlag$ = "Y" Then
          Print #OutFile%, Tab(Offset% + 3); RecipeRec.RecNo;
          Print #OutFile%, Tab(Offset% + 11); RecipeRec.RecDesc;
          Temp1$ = Format$((RecipeRec.RecRetail / 100), "##0.00")
          Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
          Print #OutFile%, Tab(Offset% + 42); Temp1$;
          Print #OutFile%, Tab(Offset% + 49); RecipeRec.UpdateFlag;
          TotalRetail& = RecipeRec.RecRetail * RecipeRec.Servings
          Temp# = ((((TotalRetail& * 100) - RecipeCost) / (TotalRetail& * 100)) * 100)
          Temp1$ = Format$(Temp#, "##0.00")
          Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
          Print #OutFile%, Tab(Offset% + 52); Temp1$;
          Temp1$ = Format$(RecipeRec.TargetProfit * 100, "#0.00")
          Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
          Print #OutFile%, Tab(Offset% + 63); Temp1$;
          Print #OutFile%, Tab(Offset% + 72); RecipeRec.MaintenanceCode;
          Temp1$ = Format$((OldRetail / 100), "#0.00")
          Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
          Print #OutFile%, Tab(Offset% + 75); Temp1$
          RecipeCost = 0
          ItemsPrinted% = ItemsPrinted% + 1
        End If
        RecipeCost = 0
        NextRecipeKey1
        t% = DoEvents()
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Print #OutFile%, Chr$(12)
    Return

PrintHeader:
    PageNo = PageNo + 1
    If PageNo Mod 2 <> 0 Then
      GoSub SetUpGrids
      Offset% = 0
    Else
      Offset% = 84
    End If
    Print #OutFile%, HomeYPos$; HomeXPos$
    Print #OutFile%, Tab(Offset% + 2); "DELI AUTO RETAIL PRICE GUIDE  ";
    Print #OutFile%, Tab(Offset% + 40); Date$; Tab(Offset% + 70); "PAGE "; PageNo
    Print #OutFile%, Tab(Offset% + 2); "RECIPE#  DESCRIPTION                     NEW      PROFIT %  TARGET % CODE  OLD"
    ItemsPrinted% = 0
    Return

ProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    RecipeCost = RecipeCost + IngredientCost
    Return

CalculateNewRetail:
    Select Case RecipeRec.MaintenanceCode
      Case "N"
        TempUnitCost# = RecipeCost / 10000 / RecipeRec.Servings
        TargetRetail = CLng((TempUnitCost# / (1 - RecipeRec.TargetProfit)) * 100)
        PriorNine = (Int(TargetRetail / 10) * 10) - 1
        NextNine = PriorNine + 10
        If (NextNine - TargetRetail) > (TargetRetail - PriorNine) Then
          NewRetail = PriorNine
        Else
          NewRetail = NextNine
        End If
        If NewRetail <> RecipeRec.RecRetail Then
          RecipeRec.RecRetail = NewRetail
          RecipeRec.UpdateFlag = "C"
          NewRetailFlag$ = "Y"
        End If
      Case "D"
        TempUnitCost# = RecipeCost / 10000 / RecipeRec.Servings
        TargetRetail = CLng((TempUnitCost# / (1 - RecipeRec.TargetProfit)) * 100)
        PriorNinetyNine = (Int(TargetRetail / 100) * 100) - 1
        NextNinetyNine = PriorNinetyNine + 100
        If (NextNinetyNine - TargetRetail) > (TargetRetail - PriorNinetyNine) Then
          NewRetail = PriorNinetyNine
        Else
          NewRetail = NextNinetyNine
        End If
        If NewRetail <> RecipeRec.RecRetail Then
          RecipeRec.RecRetail = NewRetail
          RecipeRec.UpdateFlag = "C"
          NewRetailFlag$ = "Y"
        End If
      Case Else
    End Select
    Return

SetUpGrids:
    Landscape$ = Chr$(27) + "E" + Chr$(27) + "&l1O" + Chr$(27) + "(s16.66H"
    Gray$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c48B" + Chr$(27) + "*c10G" + Chr$(27) + "*c2P"
    HRule$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c1B" + Chr$(27) + "*c0P"
    VRule$ = Chr$(27) + "*c1A" + Chr$(27) + "*c2065B" + Chr$(27) + "*c0P"
    HomeYPos$ = Chr$(27) + "*p100Y"
    HomeXPos$ = Chr$(27) + "*p0X"
    XPos$ = Chr$(27) + "*p0X"
    EndXPos$ = Chr$(27) + "*p3000X"
    Print #OutFile%, Landscape$;
    For I% = 115 To 2115 Step 100
      Temp1$ = Str$(I%)
      YPos$ = Chr$(27) + "*p" + Right$(Temp1$, Len(Temp1$) - 1) + "Y"
      Print #OutFile%, YPos$; XPos$; Gray$
    Next I%
    Print #OutFile%, HomeYPos$; HomeXPos$; HRule$
    YPos$ = Chr$(27) + "*p215Y"
    Print #OutFile%, YPos$; HomeXPos$; HRule$
    YPos$ = Chr$(27) + "*p2165Y"
    Print #OutFile%, YPos$; HomeXPos$; HRule$
    Print #OutFile%, HomeYPos$; HomeXPos$; VRule$
    Print #OutFile%, HomeYPos$; EndXPos$; VRule$
    XPos$ = Chr$(27) + "*p1500X"
    Print #OutFile%, HomeYPos$; XPos$; VRule$
    Print #OutFile%, HomeYPos$; HomeXPos$
    Return

ErrorRoutine:
    Select Case Err
      Case 25: '** Device Fault
        Msg$ = "Printer is not ready."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 27: '** OutOfPaper
        Msg$ = "Printer is out of paper."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 57: '** Device I/O error
        Msg$ = "Check your printer."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case Else
        Msg$ = "Error " + Str(Err) + " has occurred."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
    End Select

ExitProgram:
    Close OutFile%
    Unload PrnAuto


End Sub

Sub WinPrintRoutine ()
WinMainLine:
    t% = DoEvents()
    GoSub WinInitialize
    GoSub WinPrintRecipe
    GoTo WinExitProgram

WinInitialize:
    PrintCancelFlag = False
    Printer.FontName = RTrim(CfgRec.FontName)
    Printer.FontSize = CfgRec.FontSize
    MaximumY& = (Printer.ScaleHeight - 1500)
    SaveRecGroup$ = "XXX"
    Return

WinPrintRecipe:
    Print "Deli Menu System"
    Print "Auto Price Print"
    Print "Printing...Please Wait..."
     GoSub WinPrintHeader
    t% = DoEvents()
    FirstRecipeKey1
      Do
        If Printer.CurrentY > MaximumY& Then
          Printer.NewPage
          GoSub WinPrintHeader
        End If
        RecGroupRec.RecGroup = RecipeRec.RecGroup
        ReadRecGroup
        If RecGroupSt% <> 0 Then
          RecGroupRec.RecGroupDesc = "NOT FOUND"
        End If
        If SaveRecGroup$ <> RecGroupRec.RecGroup Then
          Printer.Print Tab(2); RecGroupRec.RecGroup; " "; RecGroupRec.RecGroupDesc;
          Printer.Print " --------------------------------------------"
          If Printer.CurrentY > MaximumY& Then
            Printer.NewPage
            GoSub WinPrintHeader
          End If
          SaveRecGroup$ = RecGroupRec.RecGroup
        End If
        'Get lines of ingredients
        RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
        GetGERecipeDet
        If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
          MsgUnknownRecipeDetError
          GoTo WinExitProgram
        End If
        Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
            IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
            ReadIngredient
            If IngredientSt% = 0 Then
              PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
              PrNoUnits# = RecipeDetRec.RecDetQty
              GoSub WinProcessOneIngredient
            End If
            t% = DoEvents()
            NextRecipeDet
        Loop
        OldRetail = RecipeRec.RecRetail
        NewRetailFlag$ = "N"
        GoSub WinCalculateNewRetail
        If NewRetailFlag$ = "Y" Then
          Printer.Print Tab(3); RecipeRec.RecNo;
          Printer.Print Tab(11); RecipeRec.RecDesc;
          Temp1$ = Format$((RecipeRec.RecRetail / 100), "##0.00")
          Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
          Printer.Print Tab(42); Temp1$;
          Printer.Print Tab(49); RecipeRec.UpdateFlag;
          TotalRetail& = RecipeRec.RecRetail * RecipeRec.Servings
          Temp# = ((((TotalRetail& * 100) - RecipeCost) / (TotalRetail& * 100)) * 100)
          Temp1$ = Format$(Temp#, "##0.00")
          Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
          Printer.Print Tab(52); Temp1$;
          Temp1$ = Format$(RecipeRec.TargetProfit * 100, "#0.00")
          Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
          Printer.Print Tab(63); Temp1$;
          Printer.Print Tab(72); RecipeRec.MaintenanceCode;
          Temp1$ = Format$((OldRetail / 100), "#0.00")
          Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
          Printer.Print Tab(75); Temp1$
          RecipeCost = 0
        End If
        RecipeCost = 0
        NextRecipeKey1
        t% = DoEvents()
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Printer.EndDoc
    Return

WinPrintHeader:
    PageNo = PageNo + 1
    Printer.Print Tab(2); "DELI AUTO RETAIL PRICE GUIDE  ";
    Printer.Print Tab(40); Date$; Tab(Offset% + 70); "PAGE "; PageNo
    Printer.Print Tab(2); "RECIPE#  DESCRIPTION                     NEW      PROFIT %  TARGET % CODE  OLD"
    Return

WinProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    RecipeCost = RecipeCost + IngredientCost
    Return

WinCalculateNewRetail:
    Select Case RecipeRec.MaintenanceCode
      Case "N"
        TempUnitCost# = RecipeCost / 10000 / RecipeRec.Servings
        TargetRetail = CLng((TempUnitCost# / (1 - RecipeRec.TargetProfit)) * 100)
        PriorNine = (Int(TargetRetail / 10) * 10) - 1
        NextNine = PriorNine + 10
        If (NextNine - TargetRetail) > (TargetRetail - PriorNine) Then
          NewRetail = PriorNine
        Else
          NewRetail = NextNine
        End If
        If NewRetail <> RecipeRec.RecRetail Then
          RecipeRec.RecRetail = NewRetail
          RecipeRec.UpdateFlag = "C"
          NewRetailFlag$ = "Y"
        End If
      Case "D"
        TempUnitCost# = RecipeCost / 10000 / RecipeRec.Servings
        TargetRetail = CLng((TempUnitCost# / (1 - RecipeRec.TargetProfit)) * 100)
        PriorNinetyNine = (Int(TargetRetail / 100) * 100) - 1
        NextNinetyNine = PriorNinetyNine + 100
        If (NextNinetyNine - TargetRetail) > (TargetRetail - PriorNinetyNine) Then
          NewRetail = PriorNinetyNine
        Else
          NewRetail = NextNinetyNine
        End If
        If NewRetail <> RecipeRec.RecRetail Then
          RecipeRec.RecRetail = NewRetail
          RecipeRec.UpdateFlag = "C"
          NewRetailFlag$ = "Y"
        End If
      Case Else
    End Select
    Return

WinExitProgram:
    Unload PrnAuto



End Sub

