VERSION 2.00
Begin Form PrnLabel 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Print Shelf Labels"
   ClientHeight    =   1965
   ClientLeft      =   3480
   ClientTop       =   2670
   ClientWidth     =   3435
   ControlBox      =   0   'False
   Height          =   2370
   Icon            =   PRNLABEL.FRX:0000
   Left            =   3420
   LinkTopic       =   "PrnLabel"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1965
   ScaleWidth      =   3435
   Top             =   2325
   Width           =   3555
   Begin CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   1200
      TabIndex        =   0
      Top             =   1200
      Width           =   1215
   End
   Begin Label Label1 
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   3255
   End
End
   Dim OutFile%

Sub Command1_Click ()
  PrintCancelFlag = True
End Sub

Sub EnterRecipeNumber ()
  Msg$ = "Please enter recipe number."
  Title$ = "Input"

  Answer$ = InputBox$(Msg$, Title$)
  If Answer$ = "" Then
    PrintCancelFlag = True
  Else
    RecipeRec.RecNo = Answer$
  End If
End Sub

Sub Form_Activate ()
  Unload SupMnt
  Unload RecGrMnt
  Unload IngGrMnt
  Unload IngreMnt
  Unload RecipMnt
  If CfgRec.PrintOptNumber = 1 Then
    PrintRoutine
  Else
    WinPrintRoutine
  End If
End Sub

Sub PLocate (Xval%, Yval%, PSize%, PString$)
  XStr$ = Chr$(27) + "*p" + Right$(Str$(Xval%), Len(Str$(Xval%)) - 1) + "X"
  YStr$ = Chr$(27) + "*p" + Right$(Str$(Yval%), Len(Str$(Yval%)) - 1) + "Y"
  SizeStr$ = Chr$(27) + "(s1p" + Right$(Str$(PSize%), Len(Str$(PSize%)) - 1) + "V"
  Print #OutFile%, SizeStr$; XStr$; YStr$; PString$;
End Sub

Sub PrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop
MainLine:
    t% = DoEvents()
    GoSub Initialize
    For CopyI% = 1 To NumberOfCopies
      GoSub ShelfLabelMenu
    Next CopyI%
    GoTo ExitProgram

Initialize:
    PrintCancelFlag = False
    OutFile% = FreeFile
    Open "\dev\lpt1" For Output As OutFile% Len = 166
    On Local Error GoTo ErrorRoutine
    If CfgRec.LandPortFlag = 2 Then
      LandscapeMode$ = Chr$(27) + "&l1O"
    Else
      LandscapeMode$ = ""
    End If
    ResetPrinter$ = Chr$(27) + "E"
    CGTimes$ = Chr$(27) + "(0U" + Chr$(27) + "(s1p7v0s0b4101T"
    LeftMargin% = CfgRec.LeftMargin * 3
    TopMargin% = CfgRec.TopMargin * 3
    LabelWidth% = CfgRec.LabelWidth * 3
    LabelHeight% = CfgRec.LabelHeight * 3
    LabelRow% = 1
    LabelCol% = 1
    LabelRows% = CfgRec.LabelRows
    LabelCols% = CfgRec.LabelColumns
    SaveRecGroup$ = "XXX"
    Return

ShelfLabelMenu:
    'ReportSelection passed from calling form
    Select Case ReportSelection
      Case 1
	GoSub ShelfLabelsAll
      Case 2
	GoSub PriceChangeLabels
      Case 3
	GoSub IndividualLabels
    End Select
    Return

ShelfLabelsAll:
    Cls
    Print "Deli Menu System"
    Print "Shelf Label Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    LabelFileNo% = FreeFile
    Open "\delilabl.dta" For Random As #LabelFileNo% Len = Len(WorkRec)
    RecordNo% = 1
    t% = DoEvents()
    FirstRecipeKey1
      Do
	'Get lines of ingredients
	RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
	GetGERecipeDet
	If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
	  MsgUnknownRecipeDetError
	  GoTo ExitProgram
	End If
	Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
	    IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	    ReadIngredient
	    If IngredientSt% = 0 Then
	      PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	      PrNoUnits# = RecipeDetRec.RecDetQty
	      GoSub ProcessOneIngredient
	    End If
	    t% = DoEvents()
	    NextRecipeDet
	Loop
	WorkRec.RecNo = RecipeRec.RecNo
	WorkRec.Description = RecipeRec.RecDesc
	WorkRec.Price = Format$((RecipeRec.RecRetail / 100), "##.00")
	WorkRec.ShelfLife = Format$(RecipeRec.ShelfLifeDays, "##")
	Put #LabelFileNo%, RecordNo%, WorkRec
	Label1.Caption = WorkRec.RecNo + " " + WorkRec.Description
	RecordNo% = RecordNo% + 1
	t% = DoEvents()
	NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Close #LabelFileNo%
    If Not PrintCancelFlag Then
      GoSub PrintToLJ3
    End If
    Return

PriceChangeLabels:
    Cls
    Print "Deli Menu System"
    Print "Shelf Label Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    LabelFileNo% = FreeFile
    Open "\delilabl.dta" For Random As #LabelFileNo% Len = Len(WorkRec)
    RecordNo% = 1
    t% = DoEvents()
    FirstRecipeKey1
      Do
	'Get lines of ingredients
	RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
	GetGERecipeDet
	If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
	  MsgUnknownRecipeDetError
	  GoTo ExitProgram
	End If
	Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
	    IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	    ReadIngredient
	    If IngredientSt% = 0 Then
	      PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	      PrNoUnits# = RecipeDetRec.RecDetQty
	      GoSub ProcessOneIngredient
	    End If
	    NextRecipeDet
	Loop
	If RecipeRec.UpdateFlag <> " " Then
	  WorkRec.RecNo = RecipeRec.RecNo
	  WorkRec.Description = RecipeRec.RecDesc
	  WorkRec.Price = Format$((RecipeRec.RecRetail / 100), "##.00")
	  WorkRec.ShelfLife = Format$(RecipeRec.ShelfLifeDays, "##")
	  Put #LabelFileNo%, RecordNo%, WorkRec
	  RecordNo% = RecordNo% + 1
	End If
	t% = DoEvents()
	NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Close #LabelFileNo%
    If Not PrintCancelFlag Then
      GoSub PrintToLJ3
    End If
    Return

IndividualLabels:
    Cls
    Print "Deli Menu System"
    Print "Shelf Label Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    LabelFileNo% = FreeFile
    Open "\delilabl.dta" For Random As #LabelFileNo% Len = Len(WorkRec)
    RecordNo% = 1
    Do
      EnterRecipeNumber
      If Not PrintCancelFlag Then
       'Move the follonw to EnterRecipeNumber routine
       'RecipeRec.RecNo = Recipe$
       ReadRecipe
       Select Case RecipeSt%
	Case 0
	  'Get lines of ingredients
	  RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
	  GetGERecipeDet
	  If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
	    MsgUnknownRecipeDetError
	    GoTo ExitProgram
	  End If
	  Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
	      IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	      ReadIngredient
	      If IngredientSt% = 0 Then
		PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
		PrNoUnits# = RecipeDetRec.RecDetQty
		GoSub ProcessOneIngredient
	      End If
	      NextRecipeDet
	  Loop
	  WorkRec.RecNo = RecipeRec.RecNo
	  WorkRec.Description = RecipeRec.RecDesc
	  WorkRec.Price = Format$((RecipeRec.RecRetail / 100), "##.00")
	  WorkRec.ShelfLife = Format$(RecipeRec.ShelfLifeDays, "##")
	  Put #LabelFileNo%, RecordNo%, WorkRec
	  RecordNo% = RecordNo% + 1
	Case Else
	  MsgRecipeNotFound
       End Select
      End If
    Loop Until PrintCancelFlag = True
    Close #LabelFileNo%
    GoSub PrintToLJ3
    Return

ProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    RecipeCost = RecipeCost + IngredientCost
    Return

PrintToLJ3:
  Print #OutFile%, LandscapeMode$;
  Print #OutFile%, CGTimes$;
  LabelCol% = 1
  LabelRow% = 1
  LJ3FileNo% = FreeFile
  Open "\delilabl.dta" For Random As #LJ3FileNo% Len = Len(WorkRec)
  RecordNo% = 1
  Do
      Get #LJ3FileNo%, RecordNo%, WorkRec
      GoSub PrintALabelToLJ3
      RecordNo% = RecordNo% + 1
  Loop While RecordNo% <= LOF(LJ3FileNo%) / Len(WorkRec)
  Close LJ3FileNo%
  Print #OutFile%, ResetPrinter$;
  Kill "\delilabl.dta"
  Return

PrintALabelToLJ3:
  'Field 1
    XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.DescriptionX * 3)
    YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.DescriptionY * 3)
    PLocate XX%, YY%, CfgRec.DescriptionFS, WorkRec.Description
  'Field 2
    XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.RecipeNoX * 3)
    YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.RecipeNoY * 3)
    PLocate XX%, YY%, CfgRec.RecipeNoFS, WorkRec.RecNo
  'Field 3
    XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.PriceX * 3)
    YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.PriceY * 3)
    PLocate XX%, YY%, CfgRec.PriceFS, WorkRec.Price
  'Field 4
    If Val(WorkRec.ShelfLife) < 99 Then
      XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.ShelfLifeX * 3)
      YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.ShelfLifeY * 3)
      PLocate XX%, YY%, CfgRec.ShelfLifeFS, WorkRec.ShelfLife
    End If
  If LabelCol% = LabelCols% Then
    If LabelRow% = LabelRows% Then
      Print #OutFile%, Chr$(12)
      LabelRow% = 1
    Else
      LabelRow% = LabelRow% + 1
    End If
    LabelCol% = 1
  Else
    LabelCol% = LabelCol% + 1
  End If
Return

ErrorRoutine:
    Select Case Err
      Case 25: '** Device Fault
	Msg$ = "Printer is not ready."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
      Case 27: '** OutOfPaper
	Msg$ = "Printer is out of paper."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
      Case 57: '** Device I/O error
	Msg$ = "Check your printer."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
      Case Else
	Msg$ = "Error " + Str(Err) + " has occurred."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
    End Select

ExitProgram:
    Close OutFile%
    Unload PrnLabel

End Sub

Sub WinPrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop
    
WinMainLine:
    t% = DoEvents()
    GoSub WinInitialize
    For CopyI% = 1 To NumberOfCopies
      GoSub WinShelfLabelMenu
    Next CopyI%
    GoTo WinExitProgram

WinInitialize:
    PrintCancelFlag = False
    If CfgRec.LandPortFlag = 2 Then
      prtO.Orientation = 2  'n=1 for portrait or 2 for landscape
      x% = PrtOrient%(Printer.hDC, 30, Len(prtO), prtO, 0&)
      Printer.EndDoc   '- required to make the change take effect immediately.
      'EndDoc usually generates a FormFeed, which would be unwanted here, but in
      'this case, coming right after the PrtOrinet line, it does not. Thanks to
      'John Kesler for pointing this out.
    End If
    Printer.FontName = RTrim$(CfgRec.FontName)
    LeftMargin% = CfgRec.LeftMargin * 14.4
    TopMargin% = CfgRec.TopMargin * 14.4
    LabelWidth% = CfgRec.LabelWidth * 14.4
    LabelHeight% = CfgRec.LabelHeight * 14.4
    LabelRow% = 1
    LabelCol% = 1
    LabelRows% = CfgRec.LabelRows
    LabelCols% = CfgRec.LabelColumns
    SaveRecGroup$ = "XXX"
    Return

WinShelfLabelMenu:
    'ReportSelection passed from calling form
    Select Case ReportSelection
      Case 1
	GoSub WinShelfLabelsAll
      Case 2
	GoSub WinPriceChangeLabels
      Case 3
	GoSub WinIndividualLabels
    End Select
    Return

WinShelfLabelsAll:
    Cls
    Print "Deli Menu System"
    Print "Shelf Label Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    LabelFileNo% = FreeFile
    Open "\delilabl.dta" For Random As #LabelFileNo% Len = Len(WorkRec)
    RecordNo% = 1
    t% = DoEvents()
    FirstRecipeKey1
      Do
	'Get lines of ingredients
	RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
	GetGERecipeDet
	If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
	  MsgUnknownRecipeDetError
	  GoTo WinExitProgram
	End If
	Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
	    IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	    ReadIngredient
	    If IngredientSt% = 0 Then
	      PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	      PrNoUnits# = RecipeDetRec.RecDetQty
	      GoSub WinProcessOneIngredient
	    End If
	    t% = DoEvents()
	    NextRecipeDet
	Loop
	WorkRec.RecNo = RecipeRec.RecNo
	WorkRec.Description = RecipeRec.RecDesc
	WorkRec.Price = Format$((RecipeRec.RecRetail / 100), "##.00")
	WorkRec.ShelfLife = Format$(RecipeRec.ShelfLifeDays, "##")
	Put #LabelFileNo%, RecordNo%, WorkRec
	Label1.Caption = WorkRec.RecNo + " " + WorkRec.Description
	RecordNo% = RecordNo% + 1
	t% = DoEvents()
	NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Close #LabelFileNo%
    If Not PrintCancelFlag Then
      GoSub WinPrintToLJ3
    End If
    Return

WinPriceChangeLabels:
    Cls
    Print "Deli Menu System"
    Print "Shelf Label Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    LabelFileNo% = FreeFile
    Open "\delilabl.dta" For Random As #LabelFileNo% Len = Len(WorkRec)
    RecordNo% = 1
    t% = DoEvents()
    FirstRecipeKey1
      Do
	'Get lines of ingredients
	RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
	GetGERecipeDet
	If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
	  MsgUnknownRecipeDetError
	  GoTo WinExitProgram
	End If
	Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
	    IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	    ReadIngredient
	    If IngredientSt% = 0 Then
	      PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	      PrNoUnits# = RecipeDetRec.RecDetQty
	      GoSub WinProcessOneIngredient
	    End If
	    NextRecipeDet
	Loop
	If RecipeRec.UpdateFlag <> " " Then
	  WorkRec.RecNo = RecipeRec.RecNo
	  WorkRec.Description = RecipeRec.RecDesc
	  WorkRec.Price = Format$((RecipeRec.RecRetail / 100), "##.00")
	  WorkRec.ShelfLife = Format$(RecipeRec.ShelfLifeDays, "##")
	  Put #LabelFileNo%, RecordNo%, WorkRec
	  RecordNo% = RecordNo% + 1
	End If
	t% = DoEvents()
	NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Close #LabelFileNo%
    If Not PrintCancelFlag Then
      GoSub WinPrintToLJ3
    End If
    Return

WinIndividualLabels:
    Cls
    Print "Deli Menu System"
    Print "Shelf Label Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    LabelFileNo% = FreeFile
    Open "\delilabl.dta" For Random As #LabelFileNo% Len = Len(WorkRec)
    RecordNo% = 1
    Do
      EnterRecipeNumber
      If Not PrintCancelFlag Then
       'Move the follonw to EnterRecipeNumber routine
       'RecipeRec.RecNo = Recipe$
       ReadRecipe
       Select Case RecipeSt%
	Case 0
	  'Get lines of ingredients
	  RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
	  GetGERecipeDet
	  If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
	    MsgUnknownRecipeDetError
	    GoTo WinExitProgram
	  End If
	  Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
	      IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
	      ReadIngredient
	      If IngredientSt% = 0 Then
		PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
		PrNoUnits# = RecipeDetRec.RecDetQty
		GoSub WinProcessOneIngredient
	      End If
	      NextRecipeDet
	  Loop
	  WorkRec.RecNo = RecipeRec.RecNo
	  WorkRec.Description = RecipeRec.RecDesc
	  WorkRec.Price = Format$((RecipeRec.RecRetail / 100), "##.00")
	  WorkRec.ShelfLife = Format$(RecipeRec.ShelfLifeDays, "##")
	  Put #LabelFileNo%, RecordNo%, WorkRec
	  RecordNo% = RecordNo% + 1
	Case Else
	  MsgRecipeNotFound
       End Select
      End If
    Loop Until PrintCancelFlag = True
    Close #LabelFileNo%
    GoSub WinPrintToLJ3
    Return

WinProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    RecipeCost = RecipeCost + IngredientCost
    Return

WinPrintToLJ3:
  LabelCol% = 1
  LabelRow% = 1
  LJ3FileNo% = FreeFile
  Open "\delilabl.dta" For Random As #LJ3FileNo% Len = Len(WorkRec)
  RecordNo% = 1
  Do
      Get #LJ3FileNo%, RecordNo%, WorkRec
      GoSub WinPrintALabelToLJ3
      RecordNo% = RecordNo% + 1
  Loop While RecordNo% <= LOF(LJ3FileNo%) / Len(WorkRec)
  Close LJ3FileNo%
  Printer.EndDoc
  Kill "\delilabl.dta"
  Return

WinPrintALabelToLJ3:
  'Field 1
    XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.DescriptionX * 14.4)
    YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.DescriptionY * 14.4)
    Printer.CurrentX = XX%
    Printer.CurrentY = YY%
    Printer.FontSize = CfgRec.DescriptionFS
    Printer.Print WorkRec.Description;
  'Field 2
    XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.RecipeNoX * 14.4)
    YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.RecipeNoY * 14.4)
    Printer.CurrentX = XX%
    Printer.CurrentY = YY%
    Printer.FontSize = CfgRec.RecipeNoFS
    Printer.Print WorkRec.RecNo;
  'Field 3
    XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.PriceX * 14.4)
    YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.PriceY * 14.4)
    Printer.CurrentX = XX%
    Printer.CurrentY = YY%
    Printer.FontSize = CfgRec.PriceFS
    Printer.Print WorkRec.Price;
  'Field 4
    If Val(WorkRec.ShelfLife) < 99 Then
      XX% = LeftMargin% + ((LabelCol% - 1) * LabelWidth%) + (CfgRec.ShelfLifeX * 14.4)
      YY% = TopMargin% + ((LabelRow% - 1) * LabelHeight%) + (CfgRec.ShelfLifeY * 14.4)
      Printer.CurrentX = XX%
      Printer.CurrentY = YY%
      Printer.FontSize = CfgRec.ShelfLifeFS
      Printer.Print WorkRec.ShelfLife;
    End If
  If LabelCol% = LabelCols% Then
    If LabelRow% = LabelRows% Then
      Printer.NewPage
      LabelRow% = 1
    Else
      LabelRow% = LabelRow% + 1
    End If
    LabelCol% = 1
  Else
    LabelCol% = LabelCol% + 1
  End If
Return


WinExitProgram:
    If CfgRec.LandPortFlag = 2 Then
      prtO.Orientation = 1  'n=1 for portrait or 2 for landscape
      x% = PrtOrient%(Printer.hDC, 30, Len(prtO), prtO, 0&)
      Printer.EndDoc   '- required to make the change take effect immediately.
      Printer.Print ""
      Printer.EndDoc
    End If
    Unload PrnLabel

End Sub

