VERSION 2.00
Begin Form PrnPrice 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Print Price List"
   ClientHeight    =   1965
   ClientLeft      =   3480
   ClientTop       =   2670
   ClientWidth     =   2925
   ControlBox      =   0   'False
   Height          =   2370
   Icon            =   PRNPRICE.FRX:0000
   Left            =   3420
   LinkTopic       =   "PrnPrice"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1965
   ScaleWidth      =   2925
   Top             =   2325
   Width           =   3045
   Begin CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
End

Sub Command1_Click ()
  PrintCancelFlag = True
End Sub

Sub Form_Activate ()
  Unload SupMnt
  Unload RecGrMnt
  Unload IngGrMnt
  Unload IngreMnt
  Unload RecipMnt
  If CfgRec.PrintOptNumber = 1 Then
    PrintRoutine
  Else
    WinPrintRoutine
  End If
End Sub

Sub PrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop
MainLine:
    t% = DoEvents()
    GoSub Initialize
    For CopyI% = 1 To NumberOfCopies
      GoSub PrintRecipe
    Next CopyI%
    GoTo ExitProgram

Initialize:
    PrintCancelFlag = False
    OutFile% = FreeFile
    Open "\dev\lpt1" For Output As OutFile% Len = 166
    On Local Error GoTo ErrorRoutine
    SaveRecGroup$ = "XXX"
    Return

PrintRecipe:
    PageNo% = 0
    Cls
    Print "Deli Menu System"
    Print "Price List Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    GoSub PrintHeader
    t% = DoEvents()
    FirstRecipeKey1
      Do
        If ItemsPrinted% > 38 Then
          GoSub PrintHeader
        End If
        RecGroupRec.RecGroup = RecipeRec.RecGroup
        ReadRecGroup
        If RecGroupSt% <> 0 Then
          RecGroupRec.RecGroupDesc = "NOT FOUND"
        End If
        If SaveRecGroup$ <> RecGroupRec.RecGroup Then
          Print #OutFile%, Tab(Offset% + 2); RecGroupRec.RecGroup; " "; RecGroupRec.RecGroupDesc;
          Print #OutFile%, " -------------------------------------------"
          ItemsPrinted% = ItemsPrinted% + 1
          If ItemsPrinted% > 38 Then
            GoSub PrintHeader
          End If
          SaveRecGroup$ = RecGroupRec.RecGroup
        End If
        Print #OutFile%, Tab(Offset% + 3); RecipeRec.RecNo;
        Print #OutFile%, Tab(Offset% + 11); RecipeRec.RecDesc;
        'Get lines of ingredients
        RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
        GetGERecipeDet
        If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
          MsgUnknownRecipeDetError
          GoTo ExitProgram
        End If
        Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
            IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
            ReadIngredient
            If IngredientSt% = 0 Then
              PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
              PrNoUnits# = RecipeDetRec.RecDetQty
              GoSub ProcessOneIngredient
            End If
            t% = DoEvents()
            NextRecipeDet
        Loop
        Temp1$ = Format$((RecipeRec.RecRetail / 100), "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(Offset% + 42); Temp1$;
        Print #OutFile%, Tab(Offset% + 49); RecipeRec.UpdateFlag;
        TotalRetail& = RecipeRec.RecRetail * RecipeRec.Servings
        Temp# = ((((TotalRetail& * 100) - RecipeCost) / (TotalRetail& * 100)) * 100)
        Temp1$ = Format$(Temp#, "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(Offset% + 52); Temp1$;
        Temp1$ = Format$(RecipeRec.TargetProfit * 100, "#0.00")
        Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(Offset% + 63); Temp1$;
        Print #OutFile%, Tab(Offset% + 73); RecipeRec.MaintenanceCode;
        If RecipeRec.ShelfLifeDays = 99 Then
          Print #OutFile%,
        Else
          Print #OutFile%, Tab(Offset% + 78); RecipeRec.ShelfLifeDays
        End If
        RecipeCost = 0
        ItemsPrinted% = ItemsPrinted% + 1
        t% = DoEvents()
        NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Print #OutFile%, Chr$(12)
    Return

PrintHeader:
    PageNo% = PageNo% + 1
    If PageNo% Mod 2 <> 0 Then
      GoSub SetUpGrids
      Offset% = 0
    Else
      Offset% = 84
    End If
    Print #OutFile%, HomeYPos$; HomeXPos$
    Print #OutFile%, Tab(Offset% + 2); "DELI RETAIL PRICE GUIDE  ";
    Print #OutFile%, Tab(Offset% + 40); Date$; Tab(Offset% + 70); "PAGE "; PageNo%
    Print #OutFile%, Tab(Offset% + 2); "RECIPE#  DESCRIPTION                    RETAIL    PROFIT %  TARGET %  CODE  LIFE"
    ItemsPrinted% = 0
    Return

ProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    RecipeCost = RecipeCost + IngredientCost
    Return



SetUpGrids:
    Landscape$ = Chr$(27) + "E" + Chr$(27) + "&l1O" + Chr$(27) + "(s16.66H"
    Gray$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c48B" + Chr$(27) + "*c10G" + Chr$(27) + "*c2P"
    HRule$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c1B" + Chr$(27) + "*c0P"
    VRule$ = Chr$(27) + "*c1A" + Chr$(27) + "*c2065B" + Chr$(27) + "*c0P"
    HomeYPos$ = Chr$(27) + "*p100Y"
    HomeXPos$ = Chr$(27) + "*p0X"
    XPos$ = Chr$(27) + "*p0X"
    EndXPos$ = Chr$(27) + "*p3000X"
    Print #OutFile%, Landscape$;
    For I% = 115 To 2115 Step 100
      Temp1$ = Str$(I%)
      YPos$ = Chr$(27) + "*p" + Right$(Temp1$, Len(Temp1$) - 1) + "Y"
      Print #OutFile%, YPos$; XPos$; Gray$
    Next I%
    Print #OutFile%, HomeYPos$; HomeXPos$; HRule$
    YPos$ = Chr$(27) + "*p215Y"
    Print #OutFile%, YPos$; HomeXPos$; HRule$
    YPos$ = Chr$(27) + "*p2165Y"
    Print #OutFile%, YPos$; HomeXPos$; HRule$
    Print #OutFile%, HomeYPos$; HomeXPos$; VRule$
    Print #OutFile%, HomeYPos$; EndXPos$; VRule$
    XPos$ = Chr$(27) + "*p1500X"
    Print #OutFile%, HomeYPos$; XPos$; VRule$
    Print #OutFile%, HomeYPos$; HomeXPos$
    Return

ErrorRoutine:
    Select Case Err
      Case 25: '** Device Fault
        Msg$ = "Printer is not ready."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 27: '** OutOfPaper
        Msg$ = "Printer is out of paper."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 57: '** Device I/O error
        Msg$ = "Check your printer."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case Else
        Msg$ = "Error " + Str(Err) + " has occurred."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
    End Select

ExitProgram:
    Close OutFile%
    Unload PrnPrice

End Sub

Sub WinPrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop
WinMainLine:
    t% = DoEvents()
    GoSub WinInitialize
    For CopyI% = 1 To NumberOfCopies
      GoSub WinPrintRecipe
    Next CopyI%
    GoTo WinExitProgram

WinInitialize:
    PrintCancelFlag = False
    Printer.FontName = RTrim(CfgRec.FontName)
    Printer.FontSize = CfgRec.FontSize
    MaximumY& = (Printer.ScaleHeight - 1500)
    SaveRecGroup$ = "XXX"
    Return

WinPrintRecipe:
    PageNo% = 0
    Cls
    Print "Deli Menu System"
    Print "Price List Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    GoSub WinPrintHeadIng
    t% = DoEvents()
    FirstRecipeKey1
      Do
        If Printer.CurrentY > MaximumY& Then
          Printer.NewPage
          GoSub WinPrintHeadIng
        End If
        RecGroupRec.RecGroup = RecipeRec.RecGroup
        ReadRecGroup
        If RecGroupSt% <> 0 Then
          RecGroupRec.RecGroupDesc = "NOT FOUND"
        End If
        If SaveRecGroup$ <> RecGroupRec.RecGroup Then
          Printer.Print Tab(2); RecGroupRec.RecGroup; " "; RecGroupRec.RecGroupDesc;
          Printer.Print " -------------------------------------------"
          If Printer.CurrentY > MaximumY& Then
            Printer.NewPage
            GoSub WinPrintHeadIng
          End If
          SaveRecGroup$ = RecGroupRec.RecGroup
        End If
        Printer.Print Tab(3); RecipeRec.RecNo;
        Printer.Print Tab(11); RecipeRec.RecDesc;
        'Get lines of ingredients
        RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
        GetGERecipeDet
        If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
          MsgUnknownRecipeDetError
          GoTo WinExitProgram
        End If
        Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
            IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
            ReadIngredient
            If IngredientSt% = 0 Then
              PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
              PrNoUnits# = RecipeDetRec.RecDetQty
              GoSub WinProcessOneIngredient
            End If
            t% = DoEvents()
            NextRecipeDet
        Loop
        Temp1$ = Format$((RecipeRec.RecRetail / 100), "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(42); Temp1$;
        Printer.Print Tab(49); RecipeRec.UpdateFlag;
        TotalRetail& = RecipeRec.RecRetail * RecipeRec.Servings
        Temp# = ((((TotalRetail& * 100) - RecipeCost) / (TotalRetail& * 100)) * 100)
        Temp1$ = Format$(Temp#, "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(52); Temp1$;
        Temp1$ = Format$(RecipeRec.TargetProfit * 100, "#0.00")
        Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(63); Temp1$;
        Printer.Print Tab(73); RecipeRec.MaintenanceCode;
        If RecipeRec.ShelfLifeDays = 99 Then
          Printer.Print
        Else
          Printer.Print Tab(78); RecipeRec.ShelfLifeDays
        End If
        RecipeCost = 0
        t% = DoEvents()
        NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Printer.EndDoc
    Return

WinPrintHeadIng:
    PageNo% = PageNo% + 1
    Printer.Print Tab(2); "DELI RETAIL PRICE GUIDE  ";
    Printer.Print Tab(40); Date$; Tab(70); "PAGE "; PageNo%
    Printer.Print Tab(2); "RECIPE#  DESCRIPTION                    RETAIL    PROFIT %  TARGET %  CODE  LIFE"
    Return

WinProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    RecipeCost = RecipeCost + IngredientCost
    Return

WinExitProgram:
    Unload PrnPrice

End Sub

