VERSION 2.00
Begin Form SubsIngr 
   BackColor       =   &H00E0FFFF&
   Caption         =   "Substitute Ingredient"
   Height          =   3300
   Icon            =   SUBSINGR.FRX:0000
   Left            =   1035
   LinkTopic       =   "SubsIngr"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   2895
   ScaleWidth      =   6645
   Top             =   1140
   Width           =   6765
   Begin CommandButton CmdClose 
      Caption         =   "&Close"
      Height          =   495
      Left            =   1560
      TabIndex        =   9
      Top             =   2295
      Width           =   1215
   End
   Begin CommandButton CmdReplace 
      Caption         =   "&Replace"
      Height          =   495
      Left            =   240
      TabIndex        =   8
      Top             =   2280
      Width           =   1215
   End
   Begin TextBox TxtNew 
      Height          =   495
      Left            =   1905
      TabIndex        =   5
      Top             =   1245
      Width           =   2460
   End
   Begin TextBox TxtOld 
      Height          =   495
      Left            =   1920
      TabIndex        =   1
      Top             =   285
      Width           =   2430
   End
   Begin Label LblNewUnits 
      BackColor       =   &H00E0FFFF&
      Height          =   345
      Left            =   4455
      TabIndex        =   6
      Top             =   1320
      Width           =   1920
   End
   Begin Label LblOldUnits 
      BackColor       =   &H00E0FFFF&
      Height          =   345
      Left            =   4425
      TabIndex        =   2
      Top             =   315
      Width           =   1830
   End
   Begin Label LblNewDesc 
      BackColor       =   &H00E0FFFF&
      Height          =   330
      Left            =   1905
      TabIndex        =   7
      Top             =   1830
      Width           =   4635
   End
   Begin Label LblOldDesc 
      BackColor       =   &H00E0FFFF&
      Height          =   345
      Left            =   1920
      TabIndex        =   3
      Top             =   840
      Width           =   4455
   End
   Begin Label LblMessage 
      BackColor       =   &H00E0FFFF&
      Height          =   360
      Left            =   2880
      TabIndex        =   10
      Top             =   2370
      Width           =   3660
   End
   Begin Label LblNew 
      BackColor       =   &H00E0FFFF&
      Caption         =   "&New Ingredient"
      Height          =   330
      Left            =   255
      TabIndex        =   4
      Top             =   1335
      Width           =   1500
   End
   Begin Label LblOld 
      BackColor       =   &H00E0FFFF&
      Caption         =   "&Old Ingredient"
      Height          =   315
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1560
   End
End

Sub CmdClose_Click ()
  Unload SubsIngr
End Sub

Sub CmdReplace_Click ()
      ChangesMade% = False
      ValidOld% = False
      IngredientRec.IngKey = TxtOld.Text + String$(15 - Len(TxtOld.Text), " ")
      ReadIngredient
      Select Case IngredientSt%
        Case 0
          LblOldDesc.Caption = IngredientRec.IngDesc
          LblOldUnits.Caption = IngredientRec.IngUnitDesc
          ValidOld% = True
          OldUnits$ = IngredientRec.IngUnitDesc
        Case 3
          MsgIngredientNotOpen
          LblOldDesc.Caption = ""
          LblOldUnits.Caption = ""
        Case 4
          MsgBox "Old ingredient is not on file."
          LblOldUnits.Caption = ""
          LblOldDesc.Caption = ""
        Case Else
          MsgUnknownIngredientError
          LblOldUnits.Caption = ""
          LblOldDesc.Caption = ""
      End Select
      If ValidOld% Then
        ValidNew% = False
        IngredientRec.IngKey = TxtNew.Text + String$(15 - Len(TxtNew.Text), " ")
        ReadIngredient
        Select Case IngredientSt%
          Case 0
            LblNewDesc.Caption = IngredientRec.IngDesc
            LblNewUnits.Caption = IngredientRec.IngUnitDesc
            ValidNew% = True
            NewUnits$ = IngredientRec.IngUnitDesc
          Case 3
            MsgIngredientNotOpen
            LblNewDesc.Caption = ""
            LblNewUnits.Caption = ""
          Case 4
            MsgBox "New ingredient is not on file."
            LblNewDesc.Caption = ""
            LblNewUnits.Caption = ""
          Case Else
            MsgUnknownIngredientError
            LblNewDesc.Caption = ""
            LblNewUnits.Caption = ""
        End Select
        If ValidNew% Then
          If OldUnits$ = NewUnits$ Then
            LblMessage.Caption = "Processing..."
            RecipeDetSt% = 0
            While RecipeDetSt% = 0
              t% = DoEvents()
              RecipeDetRec.RecDetKey = "      " + TxtOld.Text + String$(15 - Len(TxtOld.Text), " ")
              ReadRecipeDetKey1
              If RecipeDetSt% = 0 Then
                RecipeDetRec.RecDetKey = Left$(RecipeDetRec.RecDetKey, 6) + TxtNew.Text + String$(15 - Len(TxtNew.Text), " ")
                UpdateRecipeDetKey1
                If RecipeDetSt% = 0 Then
                  ChangesMade% = True
                End If
              End If
            Wend
            If ChangesMade% Then
              LblMessage.Caption = "Completed successfully."
              TxtNew.Text = ""
              TxtOld.Text = ""
              LblNewDesc.Caption = ""
              LblOldDesc.Caption = ""
              LblNewUnits.Caption = ""
              LblOldUnits.Caption = ""
              TxtOld.SetFocus
            Else
              LblMessage.Caption = "No changes were made."
            End If
          Else
            MsgBox "Recipe unit descriptions must be the same on both ingredients."
          End If
        End If
      End If
      ReadRecipeDet
End Sub

Sub Form_Load ()
    Height = 3300
    Width = 6675
End Sub

Sub TxtNew_KeyPress (KeyAscii As Integer)
  If KeyAscii = 13 Then
    LblMessage.Caption = ""
    KeyAscii = 0
    If TxtNew.Text <> "" Then
      IngredientRec.IngKey = TxtNew.Text + String$(15 - Len(TxtNew.Text), " ")
      ReadIngredient
      Select Case IngredientSt%
        Case 0
          LblNewDesc.Caption = IngredientRec.IngDesc
          LblNewUnits.Caption = IngredientRec.IngUnitDesc
          TxtOld.SetFocus
        Case 3
          MsgIngredientNotOpen
          LblNewDesc.Caption = ""
          LblNewUnits.Caption = ""
          TxtNew.SetFocus
        Case 4
          MsgBox "New ingredient is not on file."
          LblNewDesc.Caption = ""
          LblNewUnits.Caption = ""
          TxtNew.SetFocus
        Case Else
          MsgUnknownIngredientError
          LblNewDesc.Caption = ""
          LblNewUnits.Caption = ""
          TxtNew.SetFocus
      End Select
    End If
  Else
    UCStrKP TxtNew, 15, KeyAscii
  End If
End Sub

Sub TxtOld_KeyPress (KeyAscii As Integer)
  If KeyAscii = 13 Then
    LblMessage.Caption = ""
    KeyAscii = 0
    If TxtOld.Text <> "" Then
      IngredientRec.IngKey = TxtOld.Text + String$(15 - Len(TxtOld.Text), " ")
      ReadIngredient
      Select Case IngredientSt%
        Case 0
          LblOldDesc.Caption = IngredientRec.IngDesc
          LblOldUnits.Caption = IngredientRec.IngUnitDesc
          TxtNew.SetFocus
        Case 3
          MsgIngredientNotOpen
          LblOldDesc.Caption = ""
          LblOldUnits.Caption = ""
          TxtOld.SetFocus
        Case 4
          MsgBox "Old ingredient is not on file."
          LblOldDesc.Caption = ""
          LblOldUnits.Caption = ""
          TxtOld.SetFocus
        Case Else
          MsgUnknownIngredientError
          LblOldDesc.Caption = ""
          LblOldUnits.Caption = ""
          TxtOld.SetFocus
      End Select
    End If
  Else
    UCStrKP TxtOld, 15, KeyAscii
  End If
End Sub

