   '******************************************************
   '*    Supplier File type                              *
   '******************************************************

    Type SupplierType
        SupplierNo       As String * 3
        SupplierDesc     As String * 30
    End Type

    Global SupplierRec As SupplierType
    Global SupplierSaveRec As SupplierType
    Global SupplierSt%
    Global SupplierKeyB$
    Global SupplierPosBlk As PosBlk

Sub CloseSupplierFile ()
  '********** Close Supplier file **********************
    SupplierKeyBufLen% = 255
    SupplierBufLen% = Len(SupplierRec)
    KeyNum% = 0
    SupplierSt% = 0
    SupplierSt% = btrcall(BCLOSE, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

Sub DeleteSupplier ()
      SupplierKeyBufLen% = 255
      SupplierBufLen% = Len(SupplierRec)
      KeyNum% = 0
      SupplierSt% = 0
      SupplierSt% = btrcall(BDELETE, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

Sub FirstSupplier ()
  If Len(SupplierKeyB$) <> 3 Then
    SupplierKeyB$ = String$(3, " ")
  End If
  SupplierKeyBufLen% = 255
  SupplierBufLen% = Len(SupplierRec)
  KeyNum% = 0
  SupplierSt% = 0
  SupplierSt% = btrcall(BFIRST, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

Sub MsgSupplierNotFound ()
  Msg$ = "Supplier not found.  Status = " + Str$(SupplierSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgSupplierNotOpen ()
        Msg$ = "Supplier file not opened."
        T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgUnknownSupplierError ()
  Msg$ = "Supplier file error.  Status = " + Str$(SupplierSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub NextSupplier ()
  If Len(SupplierKeyB$) <> 3 Then
    SupplierKeyB$ = String$(3, " ")
  End If
  SupplierKeyBufLen% = 255
  SupplierBufLen% = Len(SupplierRec)
  KeyNum% = 0
  SupplierSt% = 0
  SupplierSt% = btrcall(BNEXT, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

'
'
Sub OpenSupplierFile ()
  
  '******** Open Supplier File ********************
    SupplierKeyB$ = "suppfile.btr"
    SupplierKeyBufLen% = 255
    SupplierBufLen% = Len(SupplierRec)
    KeyNum% = 0
    SupplierSt% = 0
    SupplierSt% = btrcall(BOPEN, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
    If SupplierSt% <> 0 Then
      Msg$ = "Supplier file open failed. Status = " + Str$(SupplierSt%)
      T1% = MsgBox(Msg$, 0, "Warning!")
    End If
End Sub

Sub PreviousSupplier ()
  If Len(SupplierKeyB$) <> 3 Then
    SupplierKeyB$ = String$(3, " ")
  End If
  SupplierKeyBufLen% = 255
  SupplierBufLen% = Len(SupplierRec)
  KeyNum% = 0
  SupplierSt% = 0
  SupplierSt% = btrcall(BPREVIOUS, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

Sub ReadSupplier ()
    SupplierKeyB$ = SupplierRec.SupplierNo
    SupplierKeyBufLen% = 255
    SupplierBufLen% = Len(SupplierRec)
    KeyNum% = 0
    SupplierSt% = 0
    SupplierSt% = btrcall(BEQUAL, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

Sub UpdateSupplier ()
    SupplierKeyBufLen% = 255
    SupplierBufLen% = Len(SupplierRec)
    KeyNum% = 0
    SupplierSt% = 0
    SupplierSt% = btrcall(BUPDATE, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

Sub WriteSupplier ()
      SupplierKeyBufLen% = 255
      SupplierBufLen% = Len(SupplierRec)
      KeyNum% = 0
      SupplierSt% = 0
      SupplierSt% = btrcall(BINSERT, SupplierPosBlk, SupplierRec, SupplierBufLen%, SupplierKeyB$, SupplierKeyBufLen%, KeyNum%)
End Sub

