VERSION 2.00
Begin Form PrnIngre 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Print Ingredients"
   ClientHeight    =   1935
   ClientLeft      =   3525
   ClientTop       =   2700
   ClientWidth     =   2880
   ControlBox      =   0   'False
   Height          =   2340
   Icon            =   PRNINGRE.FRX:0000
   Left            =   3465
   LinkTopic       =   "PrnIngre"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1935
   ScaleWidth      =   2880
   Top             =   2355
   Width           =   3000
   Begin CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
End

Sub Command1_Click ()
  PrintCancelFlag = True
End Sub

Sub Form_Activate ()
  Unload SupMnt
  Unload RecGrMnt
  Unload IngGrMnt
  Unload IngreMnt
  Unload RecipMnt
  If CfgRec.PrintOptNumber = 1 Then
    PrintRoutine
  Else
    PrintWinRoutine
  End If
End Sub

Sub PrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop

MainLine:
    t% = DoEvents()
    PrintCancelFlag = False
    GoSub Initialize
    For CopyI% = 1 To NumberOfCopies
      GoSub PrintIngred
    Next CopyI%
    GoTo ExitProgram

Initialize:
    OutFile% = FreeFile
    Open "\dev\lpt1" For Output As OutFile% Len = 166
    On Local Error GoTo ErrorRoutine
    LastSupplier$ = "sta"
    Return

PrintIngred:
    Cls
    Print "Deli Menu System"
    Print "Ingredient File Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    PageNo = 0
    GoSub PrintHeading
    t% = DoEvents()
    FirstIngredientKey1
    Do
	If LinesPrinted% = 39 Then
	  GoSub PrintHeading
	End If
	IngGroupRec.IngGroup = IngredientRec.IngGroup
	ReadIngGroup
	If IngGroupRec.IngGroup <> IngGroupSave$ Then
	  Print #OutFile%, Tab(2); IngGroupRec.IngGroup;
	  Print #OutFile%, Tab(7); IngGroupRec.IngGroupDesc;
	  Print #OutFile%, String$(120, "-")
	  LinesPrinted% = LinesPrinted% + 1
	  If LinesPrinted% = 39 Then
	    GoSub PrintHeading
	  End If
	End If
	Print #OutFile%, Tab(3); Left$(IngredientRec.IngKey, 3); " "; Right$(IngredientRec.IngKey, 12);
	Print #OutFile%, Tab(21); IngredientRec.IngDesc;
	Print #OutFile%, Tab(54); IngredientRec.IngSizeDesc;
	Temp1$ = Format$(IngredientRec.IngCaseCost / 10000, "###0.0000")
	Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
	Print #OutFile%, Tab(65); Temp1$;
	Temp1$ = Format$(IngredientRec.IngPacksPerCase, "####0")
	Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
	Print #OutFile%, Tab(75); Temp1$;
	Print #OutFile%, Tab(84); IngredientRec.ingPackDesc;
	Temp1$ = Format$(IngredientRec.IngUnitsPerCase, "####0")
	Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
	Print #OutFile%, Tab(95); Temp1$;
	Print #OutFile%, Tab(104); IngredientRec.IngUnitDesc;
	Temp# = IngredientRec.IngCaseCost / 10000 / IngredientRec.IngPacksPerCase
	Temp1$ = Format$(Temp#, "###0.0000")
	Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
	Print #OutFile%, Tab(119); Temp1$;
	Temp# = IngredientRec.IngCaseCost / 10000 / IngredientRec.IngUnitsPerCase
	Temp1$ = Format$(Temp#, "###0.0000")
	Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
	Print #OutFile%, Tab(134); Temp1$
	IngGroupSave$ = IngredientRec.IngGroup
	NextIngredientKey1
	LinesPrinted% = LinesPrinted% + 1
	t% = DoEvents()
    Loop Until IngredientSt% <> 0 Or PrintCancelFlag = True
    Print #OutFile%, Chr$(27); "E"
    Return

PrintHeading:
    PageNo = PageNo + 1
    LinesPrinted% = 0
    GoSub SetUpGrids
    Print #OutFile%, Tab(2); "DELI INGREDIENT LIST"; Tab(73); Date$; Tab(150); "PAGE "; PageNo
    Print #OutFile%, Tab(3); "INGREDIENT #      DESCRIPTION                      SIZE DESC   ";
    Print #OutFile%, "CASE COST  INVENTORY UNIT      RECIPE UNIT         COST/INV UNIT     ";
    Print #OutFile%, "COST/REC UNIT"
    Return

	       
SetUpGrids:
    Landscape$ = Chr$(27) + "E" + Chr$(27) + "&l1O" + Chr$(27) + "(s16.66H"
    Gray$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c48B" + Chr$(27) + "*c10G" + Chr$(27) + "*c2P"
    HRule$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c1B" + Chr$(27) + "*c0P"
    VRule$ = Chr$(27) + "*c1A" + Chr$(27) + "*c2065B" + Chr$(27) + "*c0P"
    HomeYPos$ = Chr$(27) + "*p100Y"
    HomeXPos$ = Chr$(27) + "*p0X"
    XPos$ = Chr$(27) + "*p0X"
    EndXPos$ = Chr$(27) + "*p3000X"
    Print #OutFile%, Landscape$;
    For I% = 115 To 2115 Step 100
      Temp1$ = Str$(I%)
      YPos$ = Chr$(27) + "*p" + Right$(Temp1$, Len(Temp1$) - 1) + "Y"
      Print #OutFile%, YPos$; XPos$; Gray$
    Next I%
    Print #OutFile%, HomeYPos$; XPos$; HRule$
    YPos$ = Chr$(27) + "*p215Y"
    Print #OutFile%, YPos$; XPos$; HRule$
    YPos$ = Chr$(27) + "*p2165Y"
    Print #OutFile%, YPos$; XPos$; HRule$
    Print #OutFile%, HomeYPos$; XPos$; VRule$
    Print #OutFile%, HomeYPos$; EndXPos$; VRule$
    Print #OutFile%, HomeYPos$; HomeXPos$
    Return

ErrorRoutine:
    Select Case Err
      Case 25: '** Device Fault
	Msg$ = "Printer is not ready."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
      Case 27: '** OutOfPaper
	Msg$ = "Printer is out of paper."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
      Case 57: '** Device I/O error
	Msg$ = "Check your printer."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
      Case Else
	Msg$ = "Error " + Str(Err) + " has occurred."
	T1% = MsgBox(Msg$, 0, "Warning!")
	Resume ExitProgram
    End Select



ExitProgram:
    Close OutFile%
    Cls
    Unload PrnIngre
End Sub

Sub PrintWinRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop
WinMainLine:
    t% = DoEvents()
    GoSub WinInitialize
    For CopyI% = 1 To NumberOfCopies
      GoSub WinPrintIngred
    Next CopyI%
    GoTo WinExitProgram

WinInitialize:
    PrintCancelFlag = False
    Printer.FontName = RTrim(CfgRec.FontName)
    Printer.FontSize = CfgRec.FontSize
    MaximumY& = (Printer.ScaleHeight - 1500)
    LastSupplier$ = "sta"
    Return

WinPrintIngred:
    Cls
    Print "Deli Menu System"
    Print "Ingredient File Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    PageNo = 0
    GoSub WinPrintHeading
    t% = DoEvents()
    FirstIngredientKey1
    Do
	If Printer.CurrentY > MaximumY& Then
	  Printer.NewPage
	  GoSub WinPrintHeading
	End If
	IngGroupRec.IngGroup = IngredientRec.IngGroup
	ReadIngGroup
	If IngGroupRec.IngGroup <> IngGroupSave$ Then
	  Printer.Print Tab(2); IngGroupRec.IngGroup;
	  Printer.Print Tab(7); IngGroupRec.IngGroupDesc;
	  Printer.Print String$(97, "-")
	  If Printer.CurrentX > MaximumX& Then
	    Printer.NewPage
	    GoSub WinPrintHeading
	  End If
	End If
	Printer.Print Tab(3); Left$(IngredientRec.IngKey, 3); " "; Right$(IngredientRec.IngKey, 12);
	Printer.Print Tab(21); IngredientRec.IngDesc;
	Printer.Print Tab(53); IngredientRec.IngSizeDesc;
	Temp1$ = Format$(IngredientRec.IngCaseCost / 10000, "###0.0000")
	Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
	Printer.Print Tab(64); Temp1$;
	Temp1$ = Format$(IngredientRec.IngPacksPerCase, "####0")
	Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
	Printer.Print Tab(74); Temp1$;
	Printer.Print Tab(80); IngredientRec.ingPackDesc;
	Temp1$ = Format$(IngredientRec.IngUnitsPerCase, "####0")
	Temp1$ = String$(5 - Len(Temp1$), " ") + Temp1$
	Printer.Print Tab(91); Temp1$;
	Printer.Print Tab(97); IngredientRec.IngUnitDesc;
	Temp# = IngredientRec.IngCaseCost / 10000 / IngredientRec.IngPacksPerCase
	Temp1$ = Format$(Temp#, "###0.0000")
	Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
	Printer.Print Tab(110); Temp1$;
	Temp# = IngredientRec.IngCaseCost / 10000 / IngredientRec.IngUnitsPerCase
	Temp1$ = Format$(Temp#, "###0.0000")
	Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
	Printer.Print Tab(123); Temp1$
	IngGroupSave$ = IngredientRec.IngGroup
	NextIngredientKey1
	t% = DoEvents()
    Loop Until IngredientSt% <> 0 Or PrintCancelFlag = True
    Printer.EndDoc
    Return

WinPrintHeading:
    PageNo = PageNo + 1
    Printer.Print Tab(2); "DELI INGREDIENT LIST"; Tab(73); Date$; Tab(125); "PAGE "; PageNo
    Printer.Print Tab(3); "INGREDIENT #     DESCRIPTION                      SIZE DESC  ";
    Printer.Print "CASE COST  INVENTORY UNIT    RECIPE UNIT  COST/INV UNIT  ";
    Printer.Print "COST/REC UNIT"
    Return

WinExitProgram:
    Cls
    Unload PrnIngre

End Sub

