VERSION 2.00
Begin Form PrnOrder 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Print Order Guide"
   ClientHeight    =   1965
   ClientLeft      =   3480
   ClientTop       =   2670
   ClientWidth     =   2925
   ControlBox      =   0   'False
   Height          =   2370
   Icon            =   PRNORDER.FRX:0000
   Left            =   3420
   LinkTopic       =   "PrnOrder"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1965
   ScaleWidth      =   2925
   Top             =   2325
   Width           =   3045
   Begin CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
End

Sub Command1_Click ()
  PrintCancelFlag = True
End Sub

Sub Form_Activate ()
  Unload SupMnt
  Unload RecGrMnt
  Unload IngGrMnt
  Unload IngreMnt
  Unload RecipMnt
  If CfgRec.PrintOptNumber = 1 Then
    PrintRoutine
  Else
    WinPrintRoutine
  End If
End Sub

Sub PrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop

MainLine:
    t% = DoEvents()
    PrintCancelFlag = False
    GoSub Initialize
    For CopyI% = 1 To NumberOfCopies
      GoSub PrintIngred
    Next CopyI%
    GoTo ExitProgram

Initialize:
    OutFile% = FreeFile
    Open "\dev\lpt1" For Output As OutFile% Len = 166
    On Local Error GoTo ErrorRoutine
    LastSupplier$ = "sta"
    Return


PrintIngred:
    Cls
    Print "Deli Menu System"
    Print "Order Guide Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    PrinterReset$ = Chr$(27) + "E"
    PageNo% = 0
    GoSub PrintHeading
    t% = DoEvents()
    FirstIngredientKey1
    Do
        If LinesPrinted% = 39 Then
          GoSub PrintHeading
        End If
        IngGroupRec.IngGroup = IngredientRec.IngGroup
        ReadIngGroup
        If IngGroupRec.IngGroup <> IngGroupSave$ Then
          Print #OutFile%, Tab(2); IngGroupRec.IngGroup;
          Print #OutFile%, Tab(7); IngGroupRec.IngGroupDesc;
          Print #OutFile%, String$(38, "-")
          LinesPrinted% = LinesPrinted% + 1
          If LinesPrinted% = 39 Then
            GoSub PrintHeading
          End If
        End If
        Print #OutFile%, Tab(3); IngredientRec.IngDesc;
        Print #OutFile%, Tab(34); IngredientRec.IngSizeDesc;
        Temp1$ = Format$(IngredientRec.IngCaseCost / 10000, "###0.0000")
        Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(45); Temp1$;
        Print #OutFile%, Tab(57); Left$(IngredientRec.IngKey, 3); " "; Right$(IngredientRec.IngKey, 12);
        Temp# = IngredientRec.IngCaseCost / 10000 / IngredientRec.IngPacksPerCase
        Temp1$ = Format$(Temp#, "###0.0000")
        Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(132); Temp1$;
        Print #OutFile%, Tab(148); IngredientRec.ingPackDesc
        IngGroupSave$ = IngredientRec.IngGroup
        LinesPrinted% = LinesPrinted% + 1
        NextIngredientKey1
        t% = DoEvents()
    Loop Until IngredientSt% <> 0 Or PrintCancelFlag = True
    Print #OutFile%, PrinterReset$;
    Return

PrintHeading:
    PageNo% = PageNo% + 1
    GoSub SetUpGrids
    Print #OutFile%, Tab(2); "DELI ORDER GUIDE"; Tab(40); Date$; Tab(67); "PAGE "; PageNo%;
    Print #OutFile%, Tab(118); "WEEK END"
    Print #OutFile%, Tab(2); "ITEM DESCRIPTION                SIZE DESC  CASE COST  ";
    Print #OutFile%, "     ORDER NUMBER    INVENTORY   ORDER   INVENTORY";
    Print #OutFile%, "   ORDER   INVENTORY     INVENTORY COST   COUNT BY"
    LinesPrinted% = 0
    Return


SetUpGrids:
    Landscape$ = Chr$(27) + "E" + Chr$(27) + "&l1O" + Chr$(27) + "(s16.66H"
    Gray$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c48B" + Chr$(27) + "*c10G" + Chr$(27) + "*c2P"
    HRule$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c1B" + Chr$(27) + "*c0P"
    VRule$ = Chr$(27) + "*c1A" + Chr$(27) + "*c2065B" + Chr$(27) + "*c0P"
    HomeYPos$ = Chr$(27) + "*p100Y"
    HomeXPos$ = Chr$(27) + "*p0X"
    XPos$ = Chr$(27) + "*p0X"
    EndXPos$ = Chr$(27) + "*p3000X"
    Print #OutFile%, Landscape$;
    For I% = 115 To 2115 Step 100
      Temp1$ = Str$(I%)
      YPos$ = Chr$(27) + "*p" + Right$(Temp1$, Len(Temp1$) - 1) + "Y"
      Print #OutFile%, YPos$; XPos$; Gray$
    Next I%
    Print #OutFile%, HomeYPos$; XPos$; HRule$
    YPos$ = Chr$(27) + "*p215Y"
    Print #OutFile%, YPos$; XPos$; HRule$
    YPos$ = Chr$(27) + "*p2165Y"
    Print #OutFile%, YPos$; XPos$; HRule$
    Print #OutFile%, HomeYPos$; XPos$; VRule$
    Print #OutFile%, HomeYPos$; EndXPos$; VRule$
    For I% = 1360 To 2260 Step 180
      Temp1$ = Str$(I%)
      XPos$ = Chr$(27) + "*p" + Right$(Temp1$, Len(Temp1$) - 1) + "X"
      Print #OutFile%, HomeYPos$; XPos$; VRule$
    Next I%
    Print #OutFile%, HomeYPos$; HomeXPos$
    Return

ErrorRoutine:
    Select Case Err
      Case 25: '** Device Fault
        Msg$ = "Printer is not ready."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 27: '** OutOfPaper
        Msg$ = "Printer is out of paper."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 57: '** Device I/O error
        Msg$ = "Check your printer."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case Else
        Msg$ = "Error " + Str(Err) + " has occurred."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
    End Select

ExitProgram:
    Close OutFile%
    Cls
    Unload PrnOrder

End Sub

Sub WinPrintRoutine ()
    NumberOfCopies = 0
    Do Until NumberOfCopies > 0 And NumberOfCopies < 20
      InText$ = InputBox("How many copies?", "Copies", "1")
      NumberOfCopies = Val(InText$)
    Loop

WinMainLine:
    t% = DoEvents()
    GoSub WinInitialize
    For CopyI% = 1 To NumberOfCopies
      GoSub WinPrintIngred
    Next CopyI%
    GoTo WinExitProgram

WinInitialize:
    PrintCancelFlag = False
    Printer.FontName = RTrim(CfgRec.FontName)
    Printer.FontSize = CfgRec.FontSize
    MaximumY& = (Printer.ScaleHeight - 1500)
    LastSupplier$ = "sta"
    Return


WinPrintIngred:
    Cls
    Print "Deli Menu System"
    Print "Order Guide Print"
    Print "Printing copy "; CopyI%; " of "; NumberOfCopies
    Print "Please Wait..."
    PageNo% = 0
    GoSub WinPrintHeading
    t% = DoEvents()
    FirstIngredientKey1
    Do
        If Printer.CurrentY > MaximumY& Then
          Printer.NewPage
          GoSub WinPrintHeading
        End If
        IngGroupRec.IngGroup = IngredientRec.IngGroup
        ReadIngGroup
        If IngGroupRec.IngGroup <> IngGroupSave$ Then
          Printer.Print Tab(2); IngGroupRec.IngGroup;
          Printer.Print Tab(7); IngGroupRec.IngGroupDesc;
          Printer.Print String$(38, "-")
          If Printer.CurrentY > MaximumY& Then
            Printer.NewPage
            GoSub WinPrintHeading
          End If
        End If
        Printer.Print Tab(3); IngredientRec.IngDesc;
        Printer.Print Tab(34); IngredientRec.IngSizeDesc;
        Temp1$ = Format$(IngredientRec.IngCaseCost / 10000, "###0.0000")
        Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(45); Temp1$;
        Printer.Print Tab(57); Left$(IngredientRec.IngKey, 3); "  "; Right$(IngredientRec.IngKey, 12);
        Temp# = IngredientRec.IngCaseCost / 10000 / IngredientRec.IngPacksPerCase
        Temp1$ = Format$(Temp#, "###0.0000")
        Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(112); Temp1$;
        Printer.Print Tab(129); IngredientRec.ingPackDesc
        Printer.Print Tab(2); String(132, "-")
        IngGroupSave$ = IngredientRec.IngGroup
        NextIngredientKey1
        t% = DoEvents()
    Loop Until IngredientSt% <> 0 Or PrintCancelFlag = True
    Printer.EndDoc
    Return

WinPrintHeading:
    PageNo% = PageNo% + 1
    Printer.Print Tab(2); "DELI ORDER GUIDE"; Tab(40); Date$; Tab(67); "PAGE "; PageNo%;
    Printer.Print Tab(98); "WEEK END"
    Printer.Print Tab(2); "ITEM DESCRIPTION                SIZE DESC  CASE COST  ";
    Printer.Print "     ORDER NUMBER    INVENTORY";
    Printer.Print "   ORDER   INVENTORY     INVENTORY COST   COUNT BY"
    Return

WinExitProgram:
    Cls
    Unload PrnOrder


End Sub

