VERSION 2.00
Begin Form PrnRecip 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Print Recipes"
   ControlBox      =   0   'False
   Height          =   2370
   Icon            =   PRNRECIP.FRX:0000
   Left            =   3420
   LinkTopic       =   "PrnRecip"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1965
   ScaleWidth      =   2925
   Top             =   2325
   Width           =   3045
   Begin CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
End

Sub Command1_Click ()
  PrintCancelFlag = True
End Sub

Sub Form_Activate ()
  Unload SupMnt
  Unload RecGrMnt
  Unload IngGrMnt
  Unload IngreMnt
  Unload RecipMnt
  If CfgRec.PrintOptNumber = 1 Then
    PrintRoutine
  Else
    WinPrintRoutine
  End If
End Sub

Sub PrintRoutine ()
MainLine:
    t% = DoEvents()
    GoSub Initialize
    GoSub PrintRecipe
    GoTo ExitProgram

Initialize:
    PrintCancelFlag = False
    OutFile% = FreeFile
    Open "\dev\lpt1" For Output As OutFile% Len = 166
    On Local Error GoTo ErrorRoutine
    Return


PrintRecipe:
    Print "Deli Menu System"
    Print "Recipe File Print"
    Print "Printing...Please Wait..."
    GoSub PrintHeader
    t% = DoEvents()
    FirstRecipeKey1
      Do
        If LineNo = 39 Then
          GoSub PrintHeader
        End If
        RecGroupRec.RecGroup = RecipeRec.RecGroup
        ReadRecGroup
        If RecGroupSt% <> 0 Then
          RecGroupRec.RecGroupDesc = "NOT FOUND"
        End If
        Print #OutFile%, Tab(Offset% + 2); RecipeRec.RecNo;
        Print #OutFile%, Tab(Offset% + 11); RecipeRec.RecDesc;
        Print #OutFile%, Tab(Offset% + 43); RecipeRec.RecGroup;
        Print #OutFile%, Tab(Offset% + 48); Left$(RecGroupRec.RecGroupDesc, 17);
        Temp1$ = Format$(RecipeRec.Servings, "##0")
        Temp1$ = String$(3 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(Offset% + 66); Temp1$;
        Temp1$ = Format$(RecipeRec.ShelfLifeDays, "#0")
        Temp1$ = String$(2 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(Offset% + 74); Temp1$
        LineNo = LineNo + 1
        'Get lines of ingredients
        RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
        GetGERecipeDet
        If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
          MsgUnknownRecipeDetError
          GoTo ExitProgram
        End If
        Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
            IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
            ReadIngredient
            If IngredientSt% = 0 Then
              PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
              PrNoUnits# = RecipeDetRec.RecDetQty
              GoSub ProcessOneIngredient
            End If
            t% = DoEvents()
            NextRecipeDet
        Loop
        If LineNo = 39 Then
          GoSub PrintHeader
        End If
        Print #OutFile%, Tab(Offset% + 2); "Retail Price = ";
        Temp1$ = Format$((RecipeRec.RecRetail / 100), "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Temp1$;
        Print #OutFile%, "    Unit Cost = ";
        Temp1$ = Format$((RecipeCost / 10000 / RecipeRec.Servings), "###0.0000")
        Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Temp1$;
        Print #OutFile%, Tab(Offset% + 50); "Cost =";
        Temp1$ = Format$((RecipeCost / 10000), "###0.0000")
        Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Temp1$;
        Print #OutFile%, Tab(Offset% + 68); "Profit %";
        TotalRetail& = RecipeRec.RecRetail * RecipeRec.Servings
        Temp# = ((((TotalRetail& * 100) - RecipeCost) / (TotalRetail& * 100)) * 100)
        Temp1$ = Format$(Temp#, "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Print #OutFile%, Tab(Offset% + 76); Temp1$
        LineNo = LineNo + 1
        RecipeCost = 0
        If LineNo = 39 Then
          GoSub PrintHeader
        End If
        Print #OutFile%, Tab(Offset% + 2); String$(80, "-")
        LineNo = LineNo + 1
        t% = DoEvents()
        NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Print #OutFile%, Chr$(27); "E"
    Return

PrintHeader:
    PageNo = PageNo + 1
    If PageNo Mod 2 <> 0 Then
      GoSub SetUpGrids
      Offset% = 0
    Else
      Offset% = 84
    End If
    Print #OutFile%, HomeYPos$; HomeXPos$
    Print #OutFile%, Tab(Offset% + 2); "DELI RECIPE LIST"; Tab(Offset% + 35); Date$; Tab(Offset% + 71); "PAGE "; PageNo
    Print #OutFile%, Tab(Offset% + 2); "RECIPE#  DESCRIPTION                     RECIPE GROUP          YIELDS  LIFE"
    LineNo = 0
    Return

ProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    If IngredientSt% = 4 Then
      IngredientRec.IngKey = "ZZZZ"
      ReadIngredient
    End If
    If LineNo = 39 Then
      GoSub PrintHeader
    End If
    LineNo = LineNo + 1
    Print #OutFile%, Tab(Offset% + 2); IngredientRec.IngKey;
    Print #OutFile%, Tab(Offset% + 20); IngredientRec.IngDesc;
    Temp1$ = Format$(PrNoUnits#, "##0.00")
    Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
    Print #OutFile%, Tab(Offset% + 51); Temp1$;
    Print #OutFile%, Tab(Offset% + 59); IngredientRec.ingUnitDesc;
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    Temp1$ = Format$((IngredientCost / 10000), "###0.0000")
    Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
    Print #OutFile%, Tab(Offset% + 69); Temp1$
    RecipeCost = RecipeCost + IngredientCost
    Return



SetUpGrids:
    Landscape$ = Chr$(27) + "E" + Chr$(27) + "&l1O" + Chr$(27) + "(s16.66H"
    Gray$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c48B" + Chr$(27) + "*c10G" + Chr$(27) + "*c2P"
    HRule$ = Chr$(27) + "*c3000A" + Chr$(27) + "*c1B" + Chr$(27) + "*c0P"
    VRule$ = Chr$(27) + "*c1A" + Chr$(27) + "*c2065B" + Chr$(27) + "*c0P"
    HomeYPos$ = Chr$(27) + "*p100Y"
    HomeXPos$ = Chr$(27) + "*p0X"
    XPos$ = Chr$(27) + "*p0X"
    EndXPos$ = Chr$(27) + "*p3000X"
    Print #OutFile%, Landscape$;
    For I% = 115 To 2115 Step 100
      Temp1$ = Str$(I%)
      YPos$ = Chr$(27) + "*p" + Right$(Temp1$, Len(Temp1$) - 1) + "Y"
      Print #OutFile%, YPos$; XPos$; Gray$
    Next I%
    Print #OutFile%, HomeYPos$; HomeXPos$; HRule$
    YPos$ = Chr$(27) + "*p215Y"
    Print #OutFile%, YPos$; HomeXPos$; HRule$
    YPos$ = Chr$(27) + "*p2165Y"
    Print #OutFile%, YPos$; HomeXPos$; HRule$
    Print #OutFile%, HomeYPos$; HomeXPos$; VRule$
    Print #OutFile%, HomeYPos$; EndXPos$; VRule$
    XPos$ = Chr$(27) + "*p1500X"
    Print #OutFile%, HomeYPos$; XPos$; VRule$
    Print #OutFile%, HomeYPos$; HomeXPos$
    Return

ErrorRoutine:
    Select Case Err
      Case 25: '** Device Fault
        Msg$ = "Printer is not ready."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 27: '** OutOfPaper
        Msg$ = "Printer is out of paper."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case 57: '** Device I/O error
        Msg$ = "Check your printer."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
      Case Else
        Msg$ = "Error " + Str(Err) + " has occurred."
        T1% = MsgBox(Msg$, 0, "Warning!")
        Resume ExitProgram
    End Select

ExitProgram:
    Close OutFile%
    Unload PrnRecip

End Sub

Sub WinPrintRoutine ()
WinMainLine:
    t% = DoEvents()
    GoSub WinInitialize
    GoSub WinPrintRecipe
    GoTo WinExitProgram

WinInitialize:
    PrintCancelFlag = False
    Printer.FontName = RTrim(CfgRec.FontName)
    Printer.FontSize = CfgRec.FontSize
    MaximumY& = (Printer.ScaleHeight - 1500)
    Return


WinPrintRecipe:
    Print "Deli Menu System"
    Print "Recipe File Print"
    Print "Printing...Please Wait..."
    GoSub WinPrintHeading
    t% = DoEvents()
    FirstRecipeKey1
      Do
        If Printer.CurrentY > MaximumY& Then
          Printer.NewPage
          GoSub WinPrintHeading
        End If
        RecGroupRec.RecGroup = RecipeRec.RecGroup
        ReadRecGroup
        If RecGroupSt% <> 0 Then
          RecGroupRec.RecGroupDesc = "NOT FOUND"
        End If
        Printer.Print Tab(2); RecipeRec.RecNo;
        Printer.Print Tab(11); RecipeRec.RecDesc;
        Printer.Print Tab(43); RecipeRec.RecGroup;
        Printer.Print Tab(48); Left$(RecGroupRec.RecGroupDesc, 17);
        Temp1$ = Format$(RecipeRec.Servings, "##0")
        Temp1$ = String$(3 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(66); Temp1$;
        Temp1$ = Format$(RecipeRec.ShelfLifeDays, "#0")
        Temp1$ = String$(2 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(74); Temp1$
        LineNo = LineNo + 1
        'Get lines of ingredients
        RecipeDetRec.RecDetKey = RecipeRec.RecNo + String$(15, "0")
        GetGERecipeDet
        If RecipeDetSt% <> 9 And RecipeDetSt% <> 0 Then
          MsgUnknownRecipeDetError
          GoTo WinExitProgram
        End If
        Do Until RecipeDetSt% <> 0 Or RecipeDetRec.RecDetKey > RecipeRec.RecNo + String$(15, "Z")
            IngredientRec.IngKey = Mid$(RecipeDetRec.RecDetKey, 7, 15)
            ReadIngredient
            If IngredientSt% = 0 Then
              PrIngred$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
              PrNoUnits# = RecipeDetRec.RecDetQty
              GoSub WinProcessOneIngredient
            End If
            t% = DoEvents()
            NextRecipeDet
        Loop
        If Printer.CurrentY > MaximumY& Then
          Printer.NewPage
          GoSub WinPrintHeading
        End If
        Printer.Print Tab(2); "Retail Price = ";
        Temp1$ = Format$((RecipeRec.RecRetail / 100), "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Printer.Print Temp1$;
        Printer.Print "      Unit Cost = ";
        Temp1$ = Format$((RecipeCost / 100 / RecipeRec.Servings), "###0.00")
        Temp1$ = String$(7 - Len(Temp1$), " ") + Temp1$
        Printer.Print Temp1$;
        Printer.Print Tab(50); "Cost =";
        Temp1$ = Format$((RecipeCost / 100), "###0.00")
        Temp1$ = String$(7 - Len(Temp1$), " ") + Temp1$
        Printer.Print Temp1$;
        Printer.Print Tab(68); "Profit %";
        TotalRetail& = RecipeRec.RecRetail * RecipeRec.Servings
        Temp# = ((((TotalRetail& * 100) - RecipeCost) / (TotalRetail& * 100)) * 100)
        Temp1$ = Format$(Temp#, "##0.00")
        Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
        Printer.Print Tab(76); Temp1$
        LineNo = LineNo + 1
        RecipeCost = 0
        If Printer.CurrentY > MaximumY& Then
          Printer.NewPage
          GoSub WinPrintHeading
        End If
        Printer.Print Tab(2); String$(80, "-")
        LineNo = LineNo + 1
        t% = DoEvents()
        NextRecipeKey1
      Loop Until RecipeSt% <> 0 Or PrintCancelFlag = True
    Printer.EndDoc
    Return

WinPrintHeading:
    PageNo = PageNo + 1
    Printer.Print Tab(2); "DELI RECIPE LIST"; Tab(35); Date$; Tab(71); "PAGE "; PageNo
    Printer.Print Tab(2); "RECIPE#  DESCRIPTION                     RECIPE GROUP          YIELDS  LIFE"
    Return

WinProcessOneIngredient:
    IngredientRec.IngKey = PrIngred$
    ReadIngredient
    If IngredientSt% = 4 Then
      IngredientRec.IngKey = "ZZZZ"
      ReadIngredient
    End If
    If Printer.CurrentY > MaximumY& Then
      Printer.NewPage
      GoSub WinPrintHeading
    End If
    Printer.Print Tab(2); IngredientRec.IngKey;
    Printer.Print Tab(20); IngredientRec.IngDesc;
    Temp1$ = Format$(PrNoUnits#, "##0.00")
    Temp1$ = String$(6 - Len(Temp1$), " ") + Temp1$
    Printer.Print Tab(51); Temp1$;
    Printer.Print Tab(59); IngredientRec.ingUnitDesc;
    CostPerUnit& = IngredientRec.IngCaseCost / IngredientRec.IngUnitsPerCase
    IngredientCost = (CostPerUnit& * PrNoUnits#)
    Temp1$ = Format$((IngredientCost / 10000), "###0.0000")
    Temp1$ = String$(9 - Len(Temp1$), " ") + Temp1$
    Printer.Print Tab(69); Temp1$
    RecipeCost = RecipeCost + IngredientCost
    Return


WinExitProgram:
    Unload PrnRecip


End Sub

