   '****************************************************************
   '*    Recipe Group File type                                    *
   '****************************************************************

    Type RecGroupType
        RecGroup         As String * 4
        RecGroupDesc     As String * 30
    End Type

    Global RecGroupRec As RecGroupType
    Global RecGroupSaveRec As RecGroupType
    Global RecGroupSt%
    Global RecGroupKeyB$
    Global RecGroupPosBlk As PosBlk

Sub CloseRecGroupFile ()
  '********** Close Recipe group file **********************
    RecGroupKeyBufLen% = 255
    RecGroupBufLen% = Len(RecGroupRec)
    KeyNum% = 0
    RecGroupSt% = 0
    RecGroupSt% = btrcall(BCLOSE, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

Sub DeleteRecGroup ()
      RecGroupKeyBufLen% = 255
      RecGroupBufLen% = Len(RecGroupRec)
      KeyNum% = 0
      RecGroupSt% = 0
      RecGroupSt% = btrcall(BDELETE, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

Sub FirstRecGroup ()
  If Len(RecGroupKeyB$) <> 4 Then
    RecGroupKeyB$ = String$(4, " ")
  End If
  RecGroupKeyBufLen% = 255
  RecGroupBufLen% = Len(RecGroupRec)
  KeyNum% = 0
  RecGroupSt% = 0
  RecGroupSt% = btrcall(BFIRST, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

Sub MsgRecGroupNotFound ()
  Msg$ = "Recipe group not found.  Status = " + Str$(RecGroupSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgRecGroupNotOpen ()
        Msg$ = "Recipe group file not opened."
        T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgUnknownRecGroupError ()
  Msg$ = "Recipe group file error.  Status = " + Str$(RecGroupSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub NextRecGroup ()
  If Len(RecGroupKeyB$) <> 4 Then
    RecGroupKeyB$ = String$(4, " ")
  End If
  RecGroupKeyBufLen% = 255
  RecGroupBufLen% = Len(RecGroupRec)
  KeyNum% = 0
  RecGroupSt% = 0
  RecGroupSt% = btrcall(BNEXT, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

'
'
Sub OpenRecGroupFile ()
  
  '******** Open Recipe Group File ********************
    RecGroupKeyB$ = "regrfile.btr"
    RecGroupKeyBufLen% = 255
    RecGroupBufLen% = Len(RecGroupRec)
    KeyNum% = 0
    RecGroupSt% = 0
    RecGroupSt% = btrcall(BOPEN, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
    If RecGroupSt% <> 0 Then
      Msg$ = "Recipe group file open failed. Status = " + Str$(RecGroupSt%)
      T1% = MsgBox(Msg$, 0, "Warning!")
    End If
End Sub

Sub PreviousRecGroup ()
  If Len(RecGroupKeyB$) <> 4 Then
    RecGroupKeyB$ = String$(4, " ")
  End If
  RecGroupKeyBufLen% = 255
  RecGroupBufLen% = Len(RecGroupRec)
  KeyNum% = 0
  RecGroupSt% = 0
  RecGroupSt% = btrcall(BPREVIOUS, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

Sub ReadRecGroup ()
    RecGroupKeyB$ = RecGroupRec.RecGroup
    RecGroupKeyBufLen% = 255
    RecGroupBufLen% = Len(RecGroupRec)
    KeyNum% = 0
    RecGroupSt% = 0
    RecGroupSt% = btrcall(BEQUAL, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

Sub UpdateRecGroup ()
    RecGroupKeyBufLen% = 255
    RecGroupBufLen% = Len(RecGroupRec)
    KeyNum% = 0
    RecGroupSt% = 0
    RecGroupSt% = btrcall(BUPDATE, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

Sub WriteRecGroup ()
      RecGroupKeyBufLen% = 255
      RecGroupBufLen% = Len(RecGroupRec)
      KeyNum% = 0
      RecGroupSt% = 0
      RecGroupSt% = btrcall(BINSERT, RecGroupPosBlk, RecGroupRec, RecGroupBufLen%, RecGroupKeyB$, RecGroupKeyBufLen%, KeyNum%)
End Sub

