   '****************************************************************
   '*    Sales Mix file type                                   *
   '****************************************************************

    Type SalesMixType
        RecNo            As String * 6
        ServingsSold     As Long
    End Type


    Global SalesMixRec As SalesMixType
    Global SalesMixSaveRec As SalesMixType
    Global SalesMixSt%
    Global SalesMixKeyB$
    Global SalesMixPosBlk As PosBlk


Sub CloseSalesMixFile ()
    SalesMixKeyBufLen% = 255
    SalesMixBufLen% = Len(SalesMixRec)
    KeyNum% = 0
    SalesMixSt% = 0
    SalesMixSt% = btrcall(BCLOSE, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub DeleteSalesMix ()
      SalesMixKeyBufLen% = 255
      SalesMixBufLen% = Len(SalesMixRec)
      KeyNum% = 0
      SalesMixSt% = 0
      SalesMixSt% = btrcall(BDELETE, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub FirstSalesMix ()
  If Len(SalesMixKeyB$) <> 6 Then
    SalesMixKeyB$ = String$(6, " ")
  End If
  SalesMixKeyBufLen% = 255
  SalesMixBufLen% = Len(SalesMixRec)
  KeyNum% = 0
  SalesMixSt% = 0
  SalesMixSt% = btrcall(BFIRST, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub MsgSalesMixNotFound ()
  Msg$ = "Sales Mix not found.  Status = " + Str$(SalesMixSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgSalesMixNotOpen ()
        Msg$ = "Sales Mix file not opened."
        T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgUnknownSalesMixError ()
  Msg$ = "Sales Mix file error.  Status = " + Str$(SalesMixSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub NextSalesMix ()
  If Len(SalesMixKeyB$) <> 6 Then
    SalesMixKeyB$ = String$(6, " ")
  End If
  SalesMixKeyBufLen% = 255
  SalesMixBufLen% = Len(SalesMixRec)
  KeyNum% = 0
  SalesMixSt% = 0
  SalesMixSt% = btrcall(BNEXT, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub OpenSalesMixFile ()
    SalesMixKeyB$ = "salesmix.btr"
    SalesMixKeyBufLen% = 255
    SalesMixBufLen% = Len(SalesMixRec)
    KeyNum% = 0
    SalesMixSt% = 0
    SalesMixSt% = btrcall(BOPEN, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
    If SalesMixSt% <> 0 Then
      Msg$ = "Sales Mix file open failed. Status = " + Str$(SalesMixSt%)
      T1% = MsgBox(Msg$, 0, "Warning!")
    End If
End Sub

Sub PreviousSalesMix ()
  If Len(SalesMixKeyB$) <> 6 Then
    SalesMixKeyB$ = String$(6, " ")
  End If
  SalesMixKeyBufLen% = 255
  SalesMixBufLen% = Len(SalesMixRec)
  KeyNum% = 0
  SalesMixSt% = 0
  SalesMixSt% = btrcall(BPREVIOUS, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub ReadSalesMix ()
    SalesMixKeyB$ = SalesMixRec.RecNo
    SalesMixKeyBufLen% = 255
    SalesMixBufLen% = Len(SalesMixRec)
    KeyNum% = 0
    SalesMixSt% = 0
    SalesMixSt% = btrcall(BEQUAL, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub UpdateSalesMix ()
    SalesMixKeyBufLen% = 255
    SalesMixBufLen% = Len(SalesMixRec)
    KeyNum% = 0
    SalesMixSt% = 0
    SalesMixSt% = btrcall(BUPDATE, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

Sub WriteSalesMix ()
      SalesMixKeyBufLen% = 255
      SalesMixBufLen% = Len(SalesMixRec)
      KeyNum% = 0
      SalesMixSt% = 0
      SalesMixSt% = btrcall(BINSERT, SalesMixPosBlk, SalesMixRec, SalesMixBufLen%, SalesMixKeyB$, SalesMixKeyBufLen%, KeyNum%)
End Sub

